# Class VulkanBlendConstants

java.lang.Object
com.io7m.jcoronado.api.VulkanBlendConstants

All Implemented Interfaces:
  `VulkanBlendConstantsType`

public final class VulkanBlendConstants extends Object implements VulkanBlendConstantsType
The R, G, B, and A components of the blend constant that are used in blending.

See Also:
  - "VkPipelineColorBlendAttachmentState"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanBlendConstants.Builder`
  Builds instances of type `VulkanBlendConstants`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `float`
  `a()`
  `float`
  `b()`
  `static VulkanBlendConstants.Builder`
  `builder()`
  Creates a builder for `VulkanBlendConstants`.
  `static VulkanBlendConstants`
  `copyOf(VulkanBlendConstantsType instance)`
  Creates an immutable copy of a `VulkanBlendConstantsType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanBlendConstants` that have equal attribute values.
  `float`
  `g()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `r`, `g`, `b`, `a`.
  `static VulkanBlendConstants`
  `of(float r, float g, float b, float a)`
  Construct a new immutable `VulkanBlendConstants` instance.
  `float`
  `r()`
  `String`
  `toString()`
  Prints the immutable value `VulkanBlendConstants` with attribute values.
  `final VulkanBlendConstants`
  `withA(float value)`
  Copy the current immutable object by setting a value for the `a` attribute.
  `final VulkanBlendConstants`
  `withB(float value)`
  Copy the current immutable object by setting a value for the `b` attribute.
  `final VulkanBlendConstants`
  `withG(float value)`
  Copy the current immutable object by setting a value for the `g` attribute.
  `final VulkanBlendConstants`
  `withR(float value)`
  Copy the current immutable object by setting a value for the `r` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### r

    public float r()
    Specified by:
      `r` in interface `VulkanBlendConstantsType`
    Returns:
      The red component

  - ### g

    public float g()
    Specified by:
      `g` in interface `VulkanBlendConstantsType`
    Returns:
      The green component

  - ### b

    public float b()
    Specified by:
      `b` in interface `VulkanBlendConstantsType`
    Returns:
      The blue component

  - ### a

    public float a()
    Specified by:
      `a` in interface `VulkanBlendConstantsType`
    Returns:
      The alpha component

  - ### withR

    public final VulkanBlendConstants withR(float value)
    Copy the current immutable object by setting a value for the `r` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r
    Returns:
      A modified copy of the `this` object

  - ### withG

    public final VulkanBlendConstants withG(float value)
    Copy the current immutable object by setting a value for the `g` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for g
    Returns:
      A modified copy of the `this` object

  - ### withB

    public final VulkanBlendConstants withB(float value)
    Copy the current immutable object by setting a value for the `b` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for b
    Returns:
      A modified copy of the `this` object

  - ### withA

    public final VulkanBlendConstants withA(float value)
    Copy the current immutable object by setting a value for the `a` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for a
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanBlendConstants` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `r`, `g`, `b`, `a`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanBlendConstants` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanBlendConstants of(float r, float g, float b, float a)
    Construct a new immutable `VulkanBlendConstants` instance.
    Parameters:
      `r` - The value for the `r` attribute
      `g` - The value for the `g` attribute
      `b` - The value for the `b` attribute
      `a` - The value for the `a` attribute
    Returns:
      An immutable VulkanBlendConstants instance

  - ### copyOf

    public static VulkanBlendConstants copyOf(VulkanBlendConstantsType instance)
    Creates an immutable copy of a `VulkanBlendConstantsType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanBlendConstants instance

  - ### builder

    public static VulkanBlendConstants.Builder builder()
    Creates a builder for `VulkanBlendConstants`.

         VulkanBlendConstants.builder()
            .setR(float) // required r
            .setG(float) // required g
            .setB(float) // required b
            .setA(float) // required a
            .build();

    Returns:
      A new VulkanBlendConstants builder